## primesieve 11.0+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4...3.22)
project(primesieve CXX)
set(PRIMESIEVE_VERSION "11.0")
set(PRIMESIEVE_SOVERSION "11.0.0")

# Build options ######################################################

option(BUILD_PRIMESIEVE  "Build primesieve binary"       ON)
option(BUILD_STATIC_LIBS "Build static libprimesieve"    ON)
option(BUILD_DOC         "Build C/C++ API documentation" OFF)
option(BUILD_MANPAGE     "Regenerate man page using a2x" OFF)
option(BUILD_EXAMPLES    "Build example programs"        OFF)
option(BUILD_TESTS       "Build test programs"           OFF)

# By default we enable building the shared libprimesieve library.
# However, the Emscripten WebAssembly compiler does not
# support shared libraries, hence we disable building the
# shared libprimesieve when using Emscripten.
get_property(SHARED_LIBS_SUPPORTED GLOBAL PROPERTY TARGET_SUPPORTS_SHARED_LIBS)
if(SHARED_LIBS_SUPPORTED)
    option(BUILD_SHARED_LIBS "Build shared libprimesieve" ON)
else()
    option(BUILD_SHARED_LIBS "Build shared libprimesieve" OFF)
endif()

option(WITH_MULTIARCH       "Enable runtime dispatching to fastest supported CPU instruction set" ON)
option(WITH_MSVC_CRT_STATIC "Link primesieve.lib with /MT instead of the default /MD" OFF)

# libprimesieve sanity check #########################################

if(NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
    message(FATAL_ERROR "One or both of BUILD_SHARED_LIBS or BUILD_STATIC_LIBS must be set to ON")
endif()

# Set default build type to Release ##################################

if(NOT CMAKE_VERSION VERSION_LESS 3.9)
    get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
elseif(CMAKE_CONFIGURATION_TYPES)
    set(isMultiConfig TRUE)
endif()

if(NOT isMultiConfig AND NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

# primesieve binary source files #####################################

set(BIN_SRC src/app/cmdoptions.cpp
            src/app/help.cpp
            src/app/main.cpp
            src/app/test.cpp)

# primesieve library source files ####################################

set(LIB_SRC src/api-c.cpp
            src/api.cpp
            src/CountPrintPrimes.cpp
            src/CpuInfo.cpp
            src/Erat.cpp
            src/EratSmall.cpp
            src/EratMedium.cpp
            src/EratBig.cpp
            src/iterator-c.cpp
            src/iterator.cpp
            src/IteratorHelper.cpp
            src/LookupTables.cpp
            src/MemoryPool.cpp
            src/PrimeGenerator.cpp
            src/nthPrime.cpp
            src/ParallelSieve.cpp
            src/popcount.cpp
            src/PreSieve.cpp
            src/PrimeSieve.cpp
            src/SievingPrimes.cpp)

# Required includes ##################################################

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

# MSVC DLL support (Windows) #########################################

if(WIN32 AND NOT MINGW)
    set(WIN32_MSVC_COMPATIBLE ON)
    if(BUILD_SHARED_LIBS)
        # Export symbols to .def file
        set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
    endif()
endif()

# Check if libatomic is needed (old 32-bit systems) ##################

include("${PROJECT_SOURCE_DIR}/cmake/libatomic.cmake")

# Check if compiler supports x64 multiarch ###########################

if(WITH_MULTIARCH)
    include("${PROJECT_SOURCE_DIR}/cmake/multiarch_popcnt_bmi.cmake")
    include("${PROJECT_SOURCE_DIR}/cmake/multiarch_avx512.cmake")
endif()

# libprimesieve (shared library) #####################################

find_package(Threads REQUIRED QUIET)

if(BUILD_SHARED_LIBS)
    add_library(libprimesieve SHARED ${LIB_SRC})
    set_target_properties(libprimesieve PROPERTIES OUTPUT_NAME primesieve)
    target_link_libraries(libprimesieve PRIVATE Threads::Threads ${LIBATOMIC})
    string(REPLACE "." ";" SOVERSION_LIST ${PRIMESIEVE_SOVERSION})
    list(GET SOVERSION_LIST 0 PRIMESIEVE_SOVERSION_MAJOR)
    set_target_properties(libprimesieve PROPERTIES SOVERSION ${PRIMESIEVE_SOVERSION_MAJOR})
    set_target_properties(libprimesieve PROPERTIES VERSION ${PRIMESIEVE_SOVERSION})

    if(multiarch_popcnt_bmi)
        target_compile_definitions(libprimesieve PRIVATE "MULTIARCH_POPCNT_BMI")
    endif()
    if(multiarch_avx512)
        target_compile_definitions(libprimesieve PRIVATE "MULTIARCH_AVX512")
    endif()
    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
        target_compile_definitions(libprimesieve PRIVATE "ENABLE_ASSERT")
    endif()

    if(WIN32_MSVC_COMPATIBLE)
        # On Windows the shared library will be named primesieve.dll
        # and the associated import library will be named
        # primesieve.lib. This is an issue as the static library
        # is also named primesieve.lib. Hence we rename the import
        # library to primesieve.dll.lib. The Rust programming
        # language uses the same naming convention.
        set_target_properties(libprimesieve PROPERTIES IMPORT_SUFFIX ".dll.lib")
    endif()

    target_compile_features(libprimesieve
    PUBLIC
        cxx_alias_templates
    PRIVATE
        cxx_constexpr
        cxx_uniform_initialization
        cxx_lambdas)

    target_include_directories(libprimesieve PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

    install(TARGETS libprimesieve
            EXPORT primesieveShared
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

# libprimesieve-static ###############################################

if(BUILD_STATIC_LIBS)
    add_library(libprimesieve-static STATIC ${LIB_SRC})
    set_target_properties(libprimesieve-static PROPERTIES OUTPUT_NAME primesieve)
    target_link_libraries(libprimesieve-static PRIVATE Threads::Threads ${LIBATOMIC})

    if(multiarch_popcnt_bmi)
        target_compile_definitions(libprimesieve-static PRIVATE "MULTIARCH_POPCNT_BMI")
    endif()
    if(multiarch_avx512)
        target_compile_definitions(libprimesieve-static PRIVATE "MULTIARCH_AVX512")
    endif()
    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
        target_compile_definitions(libprimesieve-static PRIVATE "ENABLE_ASSERT")
    endif()

    if(WITH_MSVC_CRT_STATIC)
        set_target_properties(libprimesieve-static PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
    endif()

    if(TARGET libprimesieve)
        add_dependencies(libprimesieve-static libprimesieve)
    endif()

    target_compile_features(libprimesieve-static
    PUBLIC
        cxx_alias_templates
    PRIVATE
        cxx_constexpr
        cxx_uniform_initialization
        cxx_lambdas)

    target_include_directories(libprimesieve-static PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

    install(TARGETS libprimesieve-static
            EXPORT primesieveStatic
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

# Static or shared linking ###########################################

# On Unix-like OSes we use shared linking against libprimesieve by
# default mainly because this is required by Linux distributions.
# On Windows we use static linking by default because the library's
# path is not encoded into the binary. This means that the binary
# will only work if the DLL is in the same directory or a directory
# that is in the PATH environment variable.

if(WIN32 AND TARGET libprimesieve-static)
    set(STATIC_LINKING ON)
elseif(NOT TARGET libprimesieve)
    set(STATIC_LINKING ON)
endif()

if(STATIC_LINKING)
    add_library(primesieve::primesieve ALIAS libprimesieve-static)
else()
    add_library(primesieve::primesieve ALIAS libprimesieve)
endif()

# primesieve binary ##################################################

if(BUILD_PRIMESIEVE)
    add_executable(primesieve ${BIN_SRC})
    target_link_libraries(primesieve primesieve::primesieve)
    target_compile_features(primesieve PRIVATE cxx_auto_type)
    install(TARGETS primesieve DESTINATION ${CMAKE_INSTALL_BINDIR})

    if(multiarch_avx512)
        target_compile_definitions(primesieve PRIVATE "MULTIARCH_AVX512")
    endif()
    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
        target_compile_definitions(primesieve PRIVATE "ENABLE_ASSERT")
    endif()

    if(WITH_MSVC_CRT_STATIC)
        set_target_properties(primesieve PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
    endif()

    if(TARGET libprimesieve-static)
        add_dependencies(primesieve libprimesieve-static)
    endif()
endif()

# Install headers ####################################################

install(FILES include/primesieve.h
              include/primesieve.hpp
              COMPONENT libprimesieve-headers
              DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

install(FILES include/primesieve/iterator.h
              include/primesieve/iterator.hpp
              include/primesieve/StorePrimes.hpp
              include/primesieve/primesieve_error.hpp
              COMPONENT libprimesieve-headers
              DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/primesieve)

# CMake find_package(primesieve) support #############################

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/primesieveConfigVersion.cmake"
    VERSION ${PRIMESIEVE_VERSION}
    COMPATIBILITY SameMajorVersion)

configure_package_config_file(
    "${PROJECT_SOURCE_DIR}/cmake/primesieveConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/primesieveConfig.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/primesieve")

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/primesieveConfig.cmake"
              "${CMAKE_CURRENT_BINARY_DIR}/primesieveConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/primesieve")

if(TARGET libprimesieve)
    install(EXPORT primesieveShared
            NAMESPACE primesieve::
            DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/primesieve")
endif()

if(TARGET libprimesieve-static)
    install(EXPORT primesieveStatic
            NAMESPACE primesieve::
            DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/primesieve")
endif()

# Regenerate man page ################################################

if(BUILD_MANPAGE)
    find_program(A2X_EXECUTABLE a2x)

    if(NOT A2X_EXECUTABLE)
        message(FATAL_ERROR "Missing a2x program (required for man page generation)!")
    else()
        message(STATUS "Found a2x: ${A2X_EXECUTABLE}")

        add_custom_command(
            TARGET ${PROJECT_NAME} POST_BUILD
            COMMAND ${A2X_EXECUTABLE}
            ARGS --format=manpage
                 -D "${PROJECT_SOURCE_DIR}/doc"
                 "${PROJECT_SOURCE_DIR}/doc/primesieve.txt"
            VERBATIM)
    endif()
endif()

# Install man page ###################################################

if(BUILD_PRIMESIEVE)
    install(FILES ${PROJECT_SOURCE_DIR}/doc/primesieve.1
            DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
endif()

# Install primesieve.pc (pkg-config) #################################

configure_file(primesieve.pc.in primesieve.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/primesieve.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# Add subdirectories #################################################

if(BUILD_DOC)
    add_subdirectory(doc)
endif()

if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

if(BUILD_TESTS)
    enable_testing()
    add_subdirectory(test)
endif()

=== debian/changelog ===
primesieve (11.0+ds-2) unstable; urgency=medium

  * Team upload
  * Raising Standards version to 4.6.2 (no change)

 -- Pierre Gruet <pgt@debian.org>  Wed, 21 Dec 2022 18:10:23 +0100

primesieve (11.0+ds-1) unstable; urgency=medium

  * New upstream major release, new (C++) ABI (minor changes).
  * Debianization:
    - various minor janitorial changes.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 10 Dec 2022 18:32:19 +0000

primesieve (8.0+ds-3) unstable; urgency=medium

  * Debianization:
    - d/watch, update;
    - d/s/lintian-overrides, update.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 27 Nov 2022 15:20:54 +0000

=== debian/control ===
Source: primesieve
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Jerome Benoit <calculus@rezozer.net>
Section: math
Priority: optional
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (=13),
 cmake,
 asciidoc-base, xmlto
Build-Depends-Indep:
 doxygen, doxygen-latex, graphviz,
 rdfind, symlinks
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/math-team/primesieve.git
Vcs-Browser: https://salsa.debian.org/math-team/primesieve
Homepage: https://github.com/kimwalisch/primesieve

Package: primesieve
Architecture: all
Multi-Arch: foreign
Depends: primesieve-bin, ${misc:Depends}
Description: fast prime number generator C/C++ library
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This dummy package provides the standard installation.

Package: libprimesieve11
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: primesieve-bin (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: fast prime number generator C/C++ library -- lib
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This package provides the shared library.

Package: libprimesieve-dev
Architecture: any
Multi-Arch: same
Replaces: libprimesieve7-dev
Breaks: libprimesieve7-dev
Section: libdevel
Depends:
 libprimesieve11 (= ${binary:Version}), libprimesieve-dev-common (= ${source:Version}),
 ${misc:Depends}
Suggests: primesieve-doc (= ${source:Version}), pkg-config
Description: fast prime number generator C/C++ library -- libdev
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This package provides the static library and symbolic links needed
 for development.

Package: libprimesieve-dev-common
Architecture: all
Multi-Arch: foreign
Replaces: libprimesieve7-dev-common
Breaks: libprimesieve7-dev-common
Section: libdevel
Depends: ${misc:Depends}
Recommends: libprimesieve-dev (= ${binary:Version})
Description: fast prime number generator C/C++ library -- headers
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This package provides the headers needed by developers.

Package: primesieve-bin
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: primesieve-doc (= ${source:Version})
Description: fast prime number generator C/C++ library -- bin
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This package provides the command line utility primesieve.

Package: primesieve-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-jquery, ${misc:Depends}
Suggests: pdf-viewer, www-browser
Enhances: primesieve-bin (= ${binary:Version}), libprimesieve-dev (= ${binary:Version})
Description: fast prime number generator C/C++ library -- doc
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This package provides the API documentation with its concomitant examples.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

## inspired from mpfr material
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS    += -O0
	CXXCFLAGS += -O0
else ifeq ($(DEB_HOST_ARCH),alpha)
	CFLAGS   += -mieee
	CXXFLAGS += -mieee
else ifeq ($(DEB_HOST_ARCH),sha4)
	CFLAGS   += -mieee
	CXXFLAGS += -mieee
else
	CFLAGS   := $(subst -O2,-O3,$(CFLAGS))
	CXXFLAGS := $(subst -O2,-O3,$(CXXFLAGS))
endif

BUILDDIR=_build

default:
	@uscan --no-conf --dehs --report || true

%:
	dh $@ --builddirectory=$(BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_TESTS=ON \
		-DBUILD_EXAMPLES=ON \
		-DBUILD_DOC=ON \
		-DBUILD_MANPAGE=ON

override_dh_auto_build-indep: README.implementation.md
	$(MAKE) -f debian/adhoc/Makefile doc

override_dh_auto_test-indep:
	true

override_dh_prep-arch: README.implementation.md

override_dh_auto_install-indep:
	DESTDIR=$(CURDIR)/debian/tmp $(CMAKE) \
			-DCMAKE_INSTALL_COMPONENT=libprimesieve-headers \
		-P $(BUILDDIR)/cmake_install.cmake

override_dh_installdocs:
	dh_installdocs -pprimesieve-bin    --link-doc=libprimesieve11
	dh_installdocs -plibprimesieve-dev --doc-main-package=libprimesieve-dev-common
	dh_installdocs --remaining-packages

override_dh_installexamples-indep:
	dh_installexamples -XCMakeLists.txt -XREADME.md

override_dh_compress-indep:
	dh_compress -X.pdf -Xexamples

README.implementation.md:
	cp -p src/README.md README.implementation.md

CMAKE ?= cmake

=== debian/tests/control ===
Test-Command: primesieve --test

Tests: make-check-bin
Depends: primesieve-bin

Tests: make-check-dev
Depends: libprimesieve-dev, build-essential, pkg-config
Restrictions: allow-stderr

Tests: build-examples
Depends: primesieve-doc, libprimesieve-dev, build-essential, pkg-config

## primesieve 11.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.4...3.22)
 project(primesieve CXX)
-set(PRIMESIEVE_VERSION "11.0")
-set(PRIMESIEVE_SOVERSION "11.0.0")
+set(PRIMESIEVE_VERSION "11.1")
+set(PRIMESIEVE_SOVERSION "11.1.0")
 
 # Build options ######################################################
 
@@ -23,8 +23,9 @@
     option(BUILD_SHARED_LIBS "Build shared libprimesieve" OFF)
 endif()
 
-option(WITH_MULTIARCH       "Enable runtime dispatching to fastest supported CPU instruction set" ON)
-option(WITH_MSVC_CRT_STATIC "Link primesieve.lib with /MT instead of the default /MD" OFF)
+option(WITH_AUTO_VECTORIZATION "Enable compiler auto-vectorization" ON)
+option(WITH_MULTIARCH          "Enable runtime dispatching to fastest supported CPU instruction set" ON)
+option(WITH_MSVC_CRT_STATIC    "Link primesieve.lib with /MT instead of the default /MD" OFF)
 
 # libprimesieve sanity check #########################################
 
@@ -94,6 +95,12 @@
 
 include("${PROJECT_SOURCE_DIR}/cmake/libatomic.cmake")
 
+# Check if compiler supports auto vectorization ######################
+
+if(WITH_AUTO_VECTORIZATION)
+    include("${PROJECT_SOURCE_DIR}/cmake/auto_vectorization.cmake")
+endif()
+
 # Check if compiler supports x64 multiarch ###########################
 
 if(WITH_MULTIARCH)
@@ -113,6 +120,7 @@
     list(GET SOVERSION_LIST 0 PRIMESIEVE_SOVERSION_MAJOR)
     set_target_properties(libprimesieve PROPERTIES SOVERSION ${PRIMESIEVE_SOVERSION_MAJOR})
     set_target_properties(libprimesieve PROPERTIES VERSION ${PRIMESIEVE_SOVERSION})
+    target_compile_options(libprimesieve PRIVATE ${FTREE_VECTORIZE_FLAG} ${FVECT_COST_MODEL_FLAG})
 
     if(multiarch_popcnt_bmi)
         target_compile_definitions(libprimesieve PRIVATE "MULTIARCH_POPCNT_BMI")
@@ -159,6 +167,7 @@
     add_library(libprimesieve-static STATIC ${LIB_SRC})
     set_target_properties(libprimesieve-static PROPERTIES OUTPUT_NAME primesieve)
     target_link_libraries(libprimesieve-static PRIVATE Threads::Threads ${LIBATOMIC})
+    target_compile_options(libprimesieve-static PRIVATE ${FTREE_VECTORIZE_FLAG} ${FVECT_COST_MODEL_FLAG})
 
     if(multiarch_popcnt_bmi)
         target_compile_definitions(libprimesieve-static PRIVATE "MULTIARCH_POPCNT_BMI")
@@ -311,7 +320,7 @@
             DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
 endif()
 
-# Install primesieve.pc (pkg-config) #################################
+# Install primesieve.pc (pkgconf) ####################################
 
 configure_file(primesieve.pc.in primesieve.pc @ONLY)
 
@@ -325,10 +334,3 @@
 endif()
 
 if(BUILD_EXAMPLES)
-    add_subdirectory(examples)
-endif()
-
-if(BUILD_TESTS)
-    enable_testing()
-    add_subdirectory(test)
-endif()

=== debian/changelog ===
primesieve (11.1+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/copyright:
      - copyright year-tuples, update;
    - d/control:
      - Standards-Version, bump to 4.6.2 (no change);
    - d/t/control:
      - dev-autogtests  allow stderr outputs (Closes: #1027814).

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 16 Jul 2023 13:00:17 +0000

## primesieve 12.0%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
-cmake_minimum_required(VERSION 3.4...3.22)
+cmake_minimum_required(VERSION 3.4...3.27)
 project(primesieve CXX)
-set(PRIMESIEVE_VERSION "11.1")
-set(PRIMESIEVE_SOVERSION "11.1.0")
+set(PRIMESIEVE_VERSION "12.0")
+set(PRIMESIEVE_SOVERSION "12.0.0")
 
 # Build options ######################################################
 
@@ -48,9 +48,10 @@
 
 # primesieve binary source files #####################################
 
-set(BIN_SRC src/app/cmdoptions.cpp
+set(BIN_SRC src/app/CmdOptions.cpp
             src/app/help.cpp
             src/app/main.cpp
+            src/app/stressTest.cpp
             src/app/test.cpp)
 
 # primesieve library source files ####################################
@@ -74,6 +75,7 @@
             src/popcount.cpp
             src/PreSieve.cpp
             src/PrimeSieve.cpp
+            src/RiemannR.cpp
             src/SievingPrimes.cpp)
 
 # Required includes ##################################################
@@ -330,7 +332,3 @@
 # Add subdirectories #################################################
 
 if(BUILD_DOC)
-    add_subdirectory(doc)
-endif()
-
-if(BUILD_EXAMPLES)

## primesieve 12.0+ds

=== test/CMakeLists.txt ===
enable_language(C)
file(GLOB files "*.cpp" "*.c")

foreach(file ${files})
    get_filename_component(binary_name ${file} NAME_WE)
    add_executable(${binary_name} ${file})
    target_link_libraries(${binary_name} primesieve::primesieve)
    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
        target_compile_definitions(${binary_name} PRIVATE "ENABLE_ASSERT")
    endif()
    add_test(NAME ${binary_name} COMMAND ${binary_name})
endforeach()

=== debian/changelog ===
primesieve (12.0+ds-2build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:49:18 +0000

primesieve (12.0+ds-2) unstable; urgency=medium

  * Debianization:
    - d/t/control:
      - Depends list, when applicable, rename pkg-config pkgconf.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 02 Mar 2024 19:30:01 +0000

primesieve (12.0+ds-1) unstable; urgency=medium

  * New upstream major version.
  * Debianization:
    - SONAME, bump to 12;
    - d/rules:
      - override_dh_installdocs target, SONAME machinery, harden;
    - d/t/make-check-dev, refresh;
    - d/control:
      - dev Suggests list, rename pkg-config pkgconf.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 24 Feb 2024 10:00:50 +0000

primesieve (11.2+ds-2) unstable; urgency=medium

  * Fail-to-Auto-Test fix release, it appeared that some headers
    were reorganized.
  * Debianization:
    - d/t/make-check-dev, refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Fri, 26 Jan 2024 17:33:47 +0000

primesieve (11.2+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/copyright:
      - copyright year-tuples, update.

 -- Jerome Benoit <calculus@rezozer.net>  Thu, 25 Jan 2024 16:28:26 +0000

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: primesieve
-Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Jerome Benoit <calculus@rezozer.net>
 Section: math
 Priority: optional
@@ -29,7 +30,7 @@
  .
  This dummy package provides the standard installation.
 
-Package: libprimesieve11
+Package: libprimesieve12
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -52,9 +53,9 @@
 Breaks: libprimesieve7-dev
 Section: libdevel
 Depends:
- libprimesieve11 (= ${binary:Version}), libprimesieve-dev-common (= ${source:Version}),
+ libprimesieve12 (= ${binary:Version}), libprimesieve-dev-common (= ${source:Version}),
  ${misc:Depends}
-Suggests: primesieve-doc (= ${source:Version}), pkg-config
+Suggests: primesieve-doc (= ${source:Version}), pkgconf
 Description: fast prime number generator C/C++ library -- libdev
  primesieve is a free software program and C/C++ library that generates
  primes using a highly optimized sieve of Eratosthenes implementation.

## primesieve 12.3+ds

=== debian/changelog ===
primesieve (12.3+ds-1) unstable; urgency=medium

  * New upstream minor version.
  * Debianization:
    - d/t/make-check-dev, refresh;
    - d/control:
      - Standards-Version, bump to 4.7.0 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 21 Apr 2024 10:52:21 +0000

primesieve (12.1+ds-1) unstable; urgency=medium

  * New upstream minor version.
  * Debianization:
    - d/copyright:
      - Files-Excluded list, refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Thu, 14 Mar 2024 09:33:37 +0000

## primesieve 12.4+ds

=== debian/changelog ===
primesieve (12.4+ds-1) unstable; urgency=medium

  * New upstream minor version.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 01 Sep 2024 12:55:50 +0000

## primesieve 12.6+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.4...3.27)
 project(primesieve CXX)
-set(PRIMESIEVE_VERSION "12.0")
-set(PRIMESIEVE_SOVERSION "12.0.0")
+set(PRIMESIEVE_VERSION "12.6")
+set(PRIMESIEVE_SOVERSION "12.6.0")
 
 # Build options ######################################################
 
@@ -44,6 +44,10 @@
 if(NOT isMultiConfig AND NOT CMAKE_BUILD_TYPE)
     set(CMAKE_BUILD_TYPE Release CACHE STRING
     "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
+endif()
+
+if(CMAKE_BUILD_TYPE STREQUAL "Debug")
+    list(APPEND PRIMESIEVE_COMPILE_DEFINITIONS "ENABLE_ASSERT")
 endif()
 
 # primesieve binary source files #####################################
@@ -78,6 +82,22 @@
             src/RiemannR.cpp
             src/SievingPrimes.cpp)
 
+# Check if compiler supports CPU multiarch ###########################
+
+if(WITH_MULTIARCH)
+    include("${PROJECT_SOURCE_DIR}/cmake/multiarch_x86_popcnt.cmake")
+    include("${PROJECT_SOURCE_DIR}/cmake/multiarch_avx512_bw.cmake")
+    include("${PROJECT_SOURCE_DIR}/cmake/multiarch_avx512_vbmi2.cmake")
+
+    if(NOT multiarch_avx512_bw)
+        include("${PROJECT_SOURCE_DIR}/cmake/multiarch_sve_arm.cmake")
+    endif()
+
+    if(multiarch_x86_popcnt OR multiarch_avx512_bw OR multiarch_avx512_vbmi2)
+        set(LIB_SRC ${LIB_SRC} src/x86/cpuid.cpp)
+    endif()
+endif()
+
 # Required includes ##################################################
 
 include(GNUInstallDirs)
@@ -103,13 +123,6 @@
     include("${PROJECT_SOURCE_DIR}/cmake/auto_vectorization.cmake")
 endif()
 
-# Check if compiler supports x64 multiarch ###########################
-
-if(WITH_MULTIARCH)
-    include("${PROJECT_SOURCE_DIR}/cmake/multiarch_popcnt_bmi.cmake")
-    include("${PROJECT_SOURCE_DIR}/cmake/multiarch_avx512.cmake")
-endif()
-
 # libprimesieve (shared library) #####################################
 
 find_package(Threads REQUIRED QUIET)
@@ -117,22 +130,13 @@
 if(BUILD_SHARED_LIBS)
     add_library(libprimesieve SHARED ${LIB_SRC})
     set_target_properties(libprimesieve PROPERTIES OUTPUT_NAME primesieve)
-    target_link_libraries(libprimesieve PRIVATE Threads::Threads ${LIBATOMIC})
+    target_link_libraries(libprimesieve PRIVATE Threads::Threads ${PRIMESIEVE_LINK_LIBRARIES})
     string(REPLACE "." ";" SOVERSION_LIST ${PRIMESIEVE_SOVERSION})
     list(GET SOVERSION_LIST 0 PRIMESIEVE_SOVERSION_MAJOR)
     set_target_properties(libprimesieve PROPERTIES SOVERSION ${PRIMESIEVE_SOVERSION_MAJOR})
     set_target_properties(libprimesieve PROPERTIES VERSION ${PRIMESIEVE_SOVERSION})
-    target_compile_options(libprimesieve PRIVATE ${FTREE_VECTORIZE_FLAG} ${FVECT_COST_MODEL_FLAG})
-
-    if(multiarch_popcnt_bmi)
-        target_compile_definitions(libprimesieve PRIVATE "MULTIARCH_POPCNT_BMI")
-    endif()
-    if(multiarch_avx512)
-        target_compile_definitions(libprimesieve PRIVATE "MULTIARCH_AVX512")
-    endif()
-    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
-        target_compile_definitions(libprimesieve PRIVATE "ENABLE_ASSERT")
-    endif()
+    target_compile_options(libprimesieve PRIVATE ${PRIMESIEVE_COMPILE_OPTIONS})
+    target_compile_definitions(libprimesieve PRIVATE ${PRIMESIEVE_COMPILE_DEFINITIONS})
 
     if(WIN32_MSVC_COMPATIBLE)
         # On Windows the shared library will be named primesieve.dll
@@ -168,18 +172,9 @@
 if(BUILD_STATIC_LIBS)
     add_library(libprimesieve-static STATIC ${LIB_SRC})
     set_target_properties(libprimesieve-static PROPERTIES OUTPUT_NAME primesieve)
-    target_link_libraries(libprimesieve-static PRIVATE Threads::Threads ${LIBATOMIC})
-    target_compile_options(libprimesieve-static PRIVATE ${FTREE_VECTORIZE_FLAG} ${FVECT_COST_MODEL_FLAG})
-
-    if(multiarch_popcnt_bmi)
-        target_compile_definitions(libprimesieve-static PRIVATE "MULTIARCH_POPCNT_BMI")
-    endif()
-    if(multiarch_avx512)
-        target_compile_definitions(libprimesieve-static PRIVATE "MULTIARCH_AVX512")
-    endif()
-    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
-        target_compile_definitions(libprimesieve-static PRIVATE "ENABLE_ASSERT")
-    endif()
+    target_link_libraries(libprimesieve-static PRIVATE Threads::Threads ${PRIMESIEVE_LINK_LIBRARIES})
+    target_compile_options(libprimesieve-static PRIVATE ${PRIMESIEVE_COMPILE_OPTIONS})
+    target_compile_definitions(libprimesieve-static PRIVATE ${PRIMESIEVE_COMPILE_DEFINITIONS})
 
     if(WITH_MSVC_CRT_STATIC)
         set_target_properties(libprimesieve-static PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
@@ -233,16 +228,10 @@
 
 if(BUILD_PRIMESIEVE)
     add_executable(primesieve ${BIN_SRC})
-    target_link_libraries(primesieve primesieve::primesieve)
+    target_link_libraries(primesieve primesieve::primesieve Threads::Threads)
+    target_compile_definitions(primesieve PRIVATE ${PRIMESIEVE_COMPILE_DEFINITIONS})
     target_compile_features(primesieve PRIVATE cxx_auto_type)
     install(TARGETS primesieve DESTINATION ${CMAKE_INSTALL_BINDIR})
-
-    if(multiarch_avx512)
-        target_compile_definitions(primesieve PRIVATE "MULTIARCH_AVX512")
-    endif()
-    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
-        target_compile_definitions(primesieve PRIVATE "ENABLE_ASSERT")
-    endif()
 
     if(WITH_MSVC_CRT_STATIC)
         set_target_properties(primesieve PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
@@ -332,3 +321,14 @@
 # Add subdirectories #################################################
 
 if(BUILD_DOC)
+    add_subdirectory(doc)
+endif()
+
+if(BUILD_EXAMPLES)
+    add_subdirectory(examples)
+endif()
+
+if(BUILD_TESTS)
+    enable_testing()
+    add_subdirectory(test)
+endif()

=== test/CMakeLists.txt ===
enable_language(C)
file(GLOB files "*.cpp" "*.c")

foreach(file ${files})
    get_filename_component(binary_name ${file} NAME_WE)
    add_executable(${binary_name} ${file})
    target_link_libraries(${binary_name} primesieve::primesieve)
    target_compile_definitions(${binary_name} PRIVATE ${PRIMESIEVE_COMPILE_DEFINITIONS})
    add_test(NAME ${binary_name} COMMAND ${binary_name})
endforeach()

=== debian/changelog ===
primesieve (12.6+ds-1) unstable; urgency=medium

  * New upstream minor version.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 01 Dec 2024 16:32:10 +0000

primesieve (12.5+ds-1) unstable; urgency=medium

  * New upstream minor version.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 10 Nov 2024 02:04:41 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: primesieve
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Jerome Benoit <calculus@rezozer.net>
 Section: math
 Priority: optional
@@ -12,7 +11,7 @@
 Build-Depends-Indep:
  doxygen, doxygen-latex, graphviz,
  rdfind, symlinks
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/math-team/primesieve.git
 Vcs-Browser: https://salsa.debian.org/math-team/primesieve
 Homepage: https://github.com/kimwalisch/primesieve

=== debian/tests/control ===
Test-Command: primesieve --test

Tests: make-check-bin
Depends: primesieve-bin

Tests: make-check-dev
Depends: libprimesieve-dev, build-essential, pkgconf
Restrictions: allow-stderr

Tests: build-examples
Depends: primesieve-doc, libprimesieve-dev, build-essential, pkgconf
Restrictions: allow-stderr

## primesieve 12.7+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.4...3.27)
 project(primesieve CXX)
-set(PRIMESIEVE_VERSION "12.6")
-set(PRIMESIEVE_SOVERSION "12.6.0")
+set(PRIMESIEVE_VERSION "12.7")
+set(PRIMESIEVE_SOVERSION "12.7.0")
 
 # Build options ######################################################
 
@@ -89,12 +89,13 @@
     include("${PROJECT_SOURCE_DIR}/cmake/multiarch_avx512_bw.cmake")
     include("${PROJECT_SOURCE_DIR}/cmake/multiarch_avx512_vbmi2.cmake")
 
-    if(NOT multiarch_avx512_bw)
+    if(multiarch_x86_popcnt OR multiarch_avx512_bw OR multiarch_avx512_vbmi2)
+        set(LIB_SRC ${LIB_SRC} src/arch/x86/cpuid.cpp)
+    else()
         include("${PROJECT_SOURCE_DIR}/cmake/multiarch_sve_arm.cmake")
-    endif()
-
-    if(multiarch_x86_popcnt OR multiarch_avx512_bw OR multiarch_avx512_vbmi2)
-        set(LIB_SRC ${LIB_SRC} src/x86/cpuid.cpp)
+        if(multiarch_sve_arm)
+            set(LIB_SRC ${LIB_SRC} src/arch/arm/sve.cpp)
+        endif()
     endif()
 endif()

=== debian/changelog ===
primesieve (12.7+ds-1) unstable; urgency=medium

  * New upstream minor version.
  * Debianization:
    - d/{copyright,adhoc/{c,cpp}/Makefile, copyright year-tuples, refrech;
    - d/control:
      - Standards-Version, bump to 4.7.2 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 09 Mar 2025 14:57:31 +0000

## primesieve 12.9%2Bds

=== debian/watch ===
version=4
opts=repack,repacksuffix=+ds,compression=xz,dversionmangle=s/\+ds//,uversionmangle=s/-rc/~rc/,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/primesieve-$1\.tar\.gz/ \
https://github.com/kimwalisch/primesieve/tags .*/archive/refs/tags/v?(\d\S*)\.tar\.gz

## primesieve 12.9+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.4...3.27)
 project(primesieve CXX)
-set(PRIMESIEVE_VERSION "12.7")
-set(PRIMESIEVE_SOVERSION "12.7.0")
+set(PRIMESIEVE_VERSION "12.9")
+set(PRIMESIEVE_SOVERSION "12.9.0")
 
 # Build options ######################################################
 
@@ -23,9 +23,8 @@
     option(BUILD_SHARED_LIBS "Build shared libprimesieve" OFF)
 endif()
 
-option(WITH_AUTO_VECTORIZATION "Enable compiler auto-vectorization" ON)
-option(WITH_MULTIARCH          "Enable runtime dispatching to fastest supported CPU instruction set" ON)
-option(WITH_MSVC_CRT_STATIC    "Link primesieve.lib with /MT instead of the default /MD" OFF)
+option(WITH_MULTIARCH       "Enable runtime dispatching to fastest supported CPU instruction set" ON)
+option(WITH_MSVC_CRT_STATIC "Link primesieve.lib with /MT instead of the default /MD" OFF)
 
 # libprimesieve sanity check #########################################
 
@@ -78,7 +77,7 @@
             src/ParallelSieve.cpp
             src/popcount.cpp
             src/PreSieve.cpp
-            src/PrimeSieve.cpp
+            src/PrimeSieveClass.cpp
             src/RiemannR.cpp
             src/SievingPrimes.cpp)
 
@@ -117,12 +116,6 @@
 # Check if libatomic is needed (old 32-bit systems) ##################
 
 include("${PROJECT_SOURCE_DIR}/cmake/libatomic.cmake")
-
-# Check if compiler supports auto vectorization ######################
-
-if(WITH_AUTO_VECTORIZATION)
-    include("${PROJECT_SOURCE_DIR}/cmake/auto_vectorization.cmake")
-endif()
 
 # libprimesieve (shared library) #####################################
 
@@ -136,7 +129,6 @@
     list(GET SOVERSION_LIST 0 PRIMESIEVE_SOVERSION_MAJOR)
     set_target_properties(libprimesieve PROPERTIES SOVERSION ${PRIMESIEVE_SOVERSION_MAJOR})
     set_target_properties(libprimesieve PROPERTIES VERSION ${PRIMESIEVE_SOVERSION})
-    target_compile_options(libprimesieve PRIVATE ${PRIMESIEVE_COMPILE_OPTIONS})
     target_compile_definitions(libprimesieve PRIVATE ${PRIMESIEVE_COMPILE_DEFINITIONS})
 
     if(WIN32_MSVC_COMPATIBLE)
@@ -157,9 +149,12 @@
         cxx_uniform_initialization
         cxx_lambdas)
 
-    target_include_directories(libprimesieve PUBLIC
+    target_include_directories(libprimesieve
+    PUBLIC
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
-        $<INSTALL_INTERFACE:include>)
+        $<INSTALL_INTERFACE:include>
+    PRIVATE
+        ${CMAKE_CURRENT_SOURCE_DIR}/src)
 
     install(TARGETS libprimesieve
             EXPORT primesieveShared
@@ -174,15 +169,10 @@
     add_library(libprimesieve-static STATIC ${LIB_SRC})
     set_target_properties(libprimesieve-static PROPERTIES OUTPUT_NAME primesieve)
     target_link_libraries(libprimesieve-static PRIVATE Threads::Threads ${PRIMESIEVE_LINK_LIBRARIES})
-    target_compile_options(libprimesieve-static PRIVATE ${PRIMESIEVE_COMPILE_OPTIONS})
     target_compile_definitions(libprimesieve-static PRIVATE ${PRIMESIEVE_COMPILE_DEFINITIONS})
 
     if(WITH_MSVC_CRT_STATIC)
         set_target_properties(libprimesieve-static PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
-    endif()
-
-    if(TARGET libprimesieve)
-        add_dependencies(libprimesieve-static libprimesieve)
     endif()
 
     target_compile_features(libprimesieve-static
@@ -193,9 +183,12 @@
         cxx_uniform_initialization
         cxx_lambdas)
 
-    target_include_directories(libprimesieve-static PUBLIC
+    target_include_directories(libprimesieve-static
+    PUBLIC
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
-        $<INSTALL_INTERFACE:include>)
+        $<INSTALL_INTERFACE:include>
+    PRIVATE
+        ${CMAKE_CURRENT_SOURCE_DIR}/src)
 
     install(TARGETS libprimesieve-static
             EXPORT primesieveStatic
@@ -214,12 +207,12 @@
 # that is in the PATH environment variable.
 
 if(WIN32 AND TARGET libprimesieve-static)
-    set(STATIC_LINKING ON)
+    set(STATICALLY_LINK_LIBPRIMESIEVE ON)
 elseif(NOT TARGET libprimesieve)
-    set(STATIC_LINKING ON)
-endif()
-
-if(STATIC_LINKING)
+    set(STATICALLY_LINK_LIBPRIMESIEVE ON)
+endif()
+
+if(STATICALLY_LINK_LIBPRIMESIEVE)
     add_library(primesieve::primesieve ALIAS libprimesieve-static)
 else()
     add_library(primesieve::primesieve ALIAS libprimesieve)
@@ -230,16 +223,13 @@
 if(BUILD_PRIMESIEVE)
     add_executable(primesieve ${BIN_SRC})
     target_link_libraries(primesieve primesieve::primesieve Threads::Threads)
+    target_include_directories(primesieve PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/src)
     target_compile_definitions(primesieve PRIVATE ${PRIMESIEVE_COMPILE_DEFINITIONS})
     target_compile_features(primesieve PRIVATE cxx_auto_type)
     install(TARGETS primesieve DESTINATION ${CMAKE_INSTALL_BINDIR})
 
     if(WITH_MSVC_CRT_STATIC)
         set_target_properties(primesieve PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
-    endif()
-
-    if(TARGET libprimesieve-static)
-        add_dependencies(primesieve libprimesieve-static)
     endif()
 endif()

=== examples/CMakeLists.txt ===
add_subdirectory(c)
add_subdirectory(cpp)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,7 @@
     get_filename_component(binary_name ${file} NAME_WE)
     add_executable(${binary_name} ${file})
     target_link_libraries(${binary_name} primesieve::primesieve)
+    target_include_directories(${binary_name} PRIVATE ${CMAKE_SOURCE_DIR}/src)
     target_compile_definitions(${binary_name} PRIVATE ${PRIMESIEVE_COMPILE_DEFINITIONS})
     add_test(NAME ${binary_name} COMMAND ${binary_name})
 endforeach()

=== examples/c/CMakeLists.txt ===
enable_language(C)
file(GLOB files "*.c")

foreach(file ${files})
    get_filename_component(binary_name ${file} NAME_WE)
    add_executable(${binary_name}_c ${file})
    target_link_libraries(${binary_name}_c primesieve::primesieve)
endforeach()

=== examples/cpp/CMakeLists.txt ===
file(GLOB files "*.cpp")
foreach(file ${files})
    get_filename_component(binary_name ${file} NAME_WE)
    add_executable(${binary_name} ${file})
    target_link_libraries(${binary_name} primesieve::primesieve)
endforeach()

=== debian/changelog ===
primesieve (12.9+ds-2) unstable; urgency=medium

  * Upload to unstable.
  * Debianization:
    - d/patches/*:
      - d/p/upstream-workaround-doc-doxygen-LaTeX-tables.patch, introduce.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 17 Aug 2025 15:17:40 +0000

primesieve (12.9+ds-1) experimental; urgency=medium

  * New upstream minor version.
  * Debianization:
    - d/tests/*:
      - d/t/control, reorder tests;
      - d/t/make-check-dev, refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 18 May 2025 13:24:37 +0000

primesieve (12.8+ds-1) experimental; urgency=medium

  * New upstream minor version.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 10 May 2025 17:24:03 +0000

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Build-Depends-Indep:
  doxygen, doxygen-latex, graphviz,
  rdfind, symlinks
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/math-team/primesieve.git
 Vcs-Browser: https://salsa.debian.org/math-team/primesieve
 Homepage: https://github.com/kimwalisch/primesieve

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,12 @@
 #!/usr/bin/make -f
+include /usr/share/dpkg/pkg-info.mk
+
+XDEB_VERSION_UPSTREAM_MAJOR=$(firstword $(subst ., ,$(DEB_VERSION_UPSTREAM)))
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+
+## see preamble in `Changes in version 11.0' section of the ChangeLog
+XDEB_SONAME=$(XDEB_VERSION_UPSTREAM_MAJOR)
 
 ## inspired from mpfr material
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
@@ -46,7 +52,7 @@
 		-P $(BUILDDIR)/cmake_install.cmake
 
 override_dh_installdocs:
-	dh_installdocs -pprimesieve-bin    --link-doc=libprimesieve11
+	dh_installdocs -pprimesieve-bin    --link-doc=libprimesieve$(XDEB_SONAME)
 	dh_installdocs -plibprimesieve-dev --doc-main-package=libprimesieve-dev-common
 	dh_installdocs --remaining-packages

=== debian/tests/control ===
Test-Command: primesieve --test

Tests: make-check-bin
Depends: primesieve-bin

Tests: build-examples
Depends: primesieve-doc, libprimesieve-dev, build-essential, pkgconf
Restrictions: allow-stderr

Tests: make-check-dev
Depends: libprimesieve-dev, build-essential, pkgconf
Restrictions: allow-stderr

## primesieve 12.10+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.4...3.27)
 project(primesieve CXX)
-set(PRIMESIEVE_VERSION "12.9")
-set(PRIMESIEVE_SOVERSION "12.9.0")
+set(PRIMESIEVE_VERSION "12.10")
+set(PRIMESIEVE_SOVERSION "12.10.0")
 
 # Build options ######################################################

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -8,4 +8,14 @@
     target_include_directories(${binary_name} PRIVATE ${CMAKE_SOURCE_DIR}/src)
     target_compile_definitions(${binary_name} PRIVATE ${PRIMESIEVE_COMPILE_DEFINITIONS})
     add_test(NAME ${binary_name} COMMAND ${binary_name})
+
+    # Copy primesieve.dll to test directory.
+    # On Windows the DLLs must be in the same directory
+    # as the binaries that depend on them.
+    if (WIN32 AND NOT STATICALLY_LINK_LIBPRIMESIEVE)
+        add_custom_command(TARGET ${binary_name} POST_BUILD
+            COMMAND ${CMAKE_COMMAND} -E copy_if_different
+                $<TARGET_FILE:libprimesieve>
+                $<TARGET_FILE_DIR:${binary_name}>)
+    endif()
 endforeach()

=== examples/c/CMakeLists.txt ===
--- 
+++ 
@@ -5,4 +5,14 @@
     get_filename_component(binary_name ${file} NAME_WE)
     add_executable(${binary_name}_c ${file})
     target_link_libraries(${binary_name}_c primesieve::primesieve)
+
+    # Copy primesieve.dll to test directory.
+    # On Windows the DLLs must be in the same directory
+    # as the binaries that depend on them.
+    if (WIN32 AND NOT STATICALLY_LINK_LIBPRIMESIEVE)
+        add_custom_command(TARGET ${binary_name}_c POST_BUILD
+            COMMAND ${CMAKE_COMMAND} -E copy_if_different
+                $<TARGET_FILE:libprimesieve>
+                $<TARGET_FILE_DIR:${binary_name}_c>)
+    endif()
 endforeach()

=== examples/cpp/CMakeLists.txt ===
--- 
+++ 
@@ -3,4 +3,14 @@
     get_filename_component(binary_name ${file} NAME_WE)
     add_executable(${binary_name} ${file})
     target_link_libraries(${binary_name} primesieve::primesieve)
+
+    # Copy primesieve.dll to test directory.
+    # On Windows the DLLs must be in the same directory
+    # as the binaries that depend on them.
+    if (WIN32 AND NOT STATICALLY_LINK_LIBPRIMESIEVE)
+        add_custom_command(TARGET ${binary_name} POST_BUILD
+            COMMAND ${CMAKE_COMMAND} -E copy_if_different
+                $<TARGET_FILE:libprimesieve>
+                $<TARGET_FILE_DIR:${binary_name}>)
+    endif()
 endforeach()

=== debian/changelog ===
primesieve (12.10+ds-1) unstable; urgency=medium

  * New upstream minor version.
  * Debianization:
    - d/patches/*:
      - d/p/upstream-workaround-doc-doxygen-LaTeX-tables.patch, integrated;
    - d/control:
      - Rules-Requires-Root field, now rely on default.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 16 Nov 2025 17:57:54 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Uploaders: Jerome Benoit <calculus@rezozer.net>
 Section: math
 Priority: optional
-Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (=13),
  cmake,
